#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <float.h>
#include <R.h>
#include <R_ext/Utils.h>
#include "dsa.h"




void DSA_PACK_printmatrix_to_file(double *x, int nrow, int ncol, char* f)
{
  FILE* fp = fopen(f, "w");

  int i,j;
  for (i=0;i<nrow;i++)
    {
      for(j=0;j<ncol;j++)
	fprintf(fp, "%lf ", x[j*nrow+i]); 
      fprintf(fp, "\n");
    }

  fclose(fp);
}


void DSA_PACK_printmatrix(double *x, int nrow, int ncol)
{
  int i,j;
  for (i=0;i<nrow;i++)
    {
      for(j=0;j<ncol;j++)Rprintf("%lf ",x[j*nrow+i]); 
      Rprintf("\n");
    }
}

void DSA_PACK_printmatrixl(int *x, int nrow, int ncol)
{
  int i,j;
  for (i=0;i<nrow;i++)
    {
      Rprintf("\n");
      for(j=0;j<ncol;j++)Rprintf("%ld ",x[j*nrow+i]); 
    }
}

double DSA_PACK_getmin(double *x,int n)
{
  double mymin;
  int i;

  mymin = *x;
  for(i=1;i<n;i++)if( (x[i]<mymin)  & (x[i]!=R_PosInf))mymin=x[i];
  return(mymin);
}

void DSA_PACK_initialize_l(int *x,int n)
{
  int i;

  for(i=0;i<n;i++)x[i]=0;
}

void DSA_PACK_initialize_d(double *x,int n)
{
  int i;

  for(i=0;i<n;i++)x[i]=0;
}

int DSA_PACK_rowsumints(int *x,int nrow,int ncol,int whichrow)
{
  int j,m;

  m=0;
  for(j=0;j<ncol;j++)m += x[j*nrow+whichrow];
  return(m);
}

int DSA_PACK_num_nonzero(int *x,int n)
{
  int i,count;

  count=0;
  for(i=0;i<n;i++)if(x[i]!=0)count++;
  return(count);
}

int DSA_PACK_sumofints(int *x,int n)
{
  int i,m;

  for(i=0,m=0;i<n;i++,m+=*x,x++);
  return(m);
}


